%% RLC Lab 2


%% Import Waveform

close all
importfile('LR_2K.csv');
time = data(:,1)*1000;
v = data(:,2);
plot(time,v);
xlabel('time (msec)');
ylabel('response (V)');


%% nominal fit
% Select one transition and compare nominal fit

close all
% start = -1.66 % 1K case
start = -1.78; % 2K case
% start = -0.24; % 3K case
% start = -2.93 % 6K case
span = 1.6;
idx = find(logical(time>start) & logical(time<(start+span)));
td = time(idx) - start ;
vd = v(idx);
% Define nominal parameters
C = 39.5e-9; % Farads
L = 49.2e-3; % Henries
R = 2000+50;
% Calculate model parameters
w = 1/sqrt(L*C);
alpha = 1/(2*R*C);
xic = alpha/w;
vf = 2.0;
fprintf('LC freq (calc) %g\n',w/(2*pi));
fprintf('xi (calc) %g\n',xic);

% run the model
w0 = w/1000; % factor of 1000 accounts for milliseconds
xi = xic;
wn  = sqrt(1-xi^2);
K = 2*xi*vf/wn;
fprintf('K %g\n',K);
t = linspace(0,span,501);
y =  K*sin(wn*w0*t).*exp(-xi*w0*t);

plot(td,vd,'LineWidth',2);
hold on
plot(t,y,'k','LineWidth',2);
hold off
xlabel('time (msec)');
ylabel('response (V)');

%% Steady-state

vlast = vd(length(vd));
ir = 0.5*vf/R;
rseries = vlast/ir;
fprintf('steady-state voltage %g V\n',vlast);
fprintf('series resistance %g ohm\n',rseries);

